﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Cvicenie4
{
    public partial class Form1 : Form
    {

        private enum Operation { PLUS, MINUS, MULTIPLY, DEVIDE }

        private int firstNumber;
        private Operation operation;
        private bool shouldClear = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "1";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "2";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "3";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "4";
        }

        private void button5_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "5";
        }

        private void button6_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "6";
        }

        private void button7_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "7";
        }

        private void button8_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "8";
        }

        private void button9_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "9";
        }

        private void button0_Click(object sender, EventArgs e)
        {
            checkClear();
            labelDisplay.Text += "0";
        }

        private void buttonPlus_Click(object sender, EventArgs e)
        {
            try {
                firstNumber = Int32.Parse(labelDisplay.Text);
                operation = Operation.PLUS;
                shouldClear = true;
            }
            catch (OverflowException)
            {
                MessageBox.Show("Zadali ste prilis velke cislo", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Clear();
            }
        }

        private void buttonMinus_Click(object sender, EventArgs e)
        {
            try
            {
                firstNumber = Int32.Parse(labelDisplay.Text);
                operation = Operation.MINUS;
                shouldClear = true;
            }
            catch (OverflowException)
            {
                MessageBox.Show("Zadali ste prilis velke cislo", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Clear();
            }
        }

        private void buttonResult_Click(object sender, EventArgs e)
        {
            try
            {
                int temp = Int32.Parse(labelDisplay.Text);
                switch (operation)
                {
                    case Operation.PLUS:
                        labelDisplay.Text = (firstNumber + temp).ToString();
                        break;
                    case Operation.MINUS:
                        labelDisplay.Text = (firstNumber - temp) + "";
                        break;
                    case Operation.MULTIPLY:
                        labelDisplay.Text = (firstNumber * temp).ToString();
                        break;
                    case Operation.DEVIDE:
                        labelDisplay.Text = (firstNumber / temp).ToString();
                        break;
                }
                firstNumber = temp;
                shouldClear = true;
            }
            catch (ArithmeticException)
            {
                MessageBox.Show("Zadali ste prilis velke cislo alebo delite nulou", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Clear();
            }
        }

        private void checkClear() 
        {
            if (shouldClear)
            {
                labelDisplay.Text = "";
                shouldClear = false;
            }
        }

        private void buttonMultiply_Click(object sender, EventArgs e)
        {
            try
            {
                firstNumber = Int32.Parse(labelDisplay.Text);
                operation = Operation.MULTIPLY;
                shouldClear = true;
            }
            catch (OverflowException)
            {
                MessageBox.Show("Zadali ste prilis velke cislo", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Clear();
            }
        }

        private void buttonDevide_Click(object sender, EventArgs e)
        {
            try
            {
                firstNumber = Int32.Parse(labelDisplay.Text);
                operation = Operation.DEVIDE;
                shouldClear = true;
            }
            catch (OverflowException)
            {
                MessageBox.Show("Zadali ste prilis velke cislo", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Clear();
            }
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            Clear();
        }

        private void Clear()
        {
            labelDisplay.Text = "";
            firstNumber = 0;
        }

        private void labelDisplay_TextChanged(object sender, EventArgs e)
        {
            if (labelDisplay.Text.Equals(""))
            {
                labelDisplay.Text = "0";
            }
            if (labelDisplay.Text.StartsWith("0") && labelDisplay.Text.Length > 1)
            {
                labelDisplay.Text = labelDisplay.Text.Substring(1);
            }
        }
    }
}
